#include <stdio.h>
#include <string.h>

#define ALPHA_SIZE 128
#define PLEN 111
#define TLEN 1111111

char Ptmp[PLEN], P[PLEN][ALPHA_SIZE], Ptype[PLEN], text[TLEN];
int T, plen, tlen, ptmplen, i, j, anymatch;

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d", &T);
	while (T--) {
		scanf("%s %s", Ptmp + 1, text + 1);
		tlen = strlen(text + 1);
		while (text[tlen] < 'A' || text[tlen] > 'z')
			tlen--;
		plen = 0;
		ptmplen = strlen(Ptmp + 1);
		memset(P, 0, sizeof(P));

		for (i = 1; i <= ptmplen; i++) {
			plen++;
			if (Ptmp[i] == '[') {
				i++;
				Ptype[plen] = 1;
				while (Ptmp[i] != ']') {
					P[plen][Ptmp[i]] = 1;
					i++;
				}
			} else if (Ptmp[i] == '{') {
				Ptype[plen] = 0;
				while (Ptmp[i] != '}') {
					P[plen][Ptmp[i]] = 1;
					i++;
				}
			} else if (Ptmp[i] == '?') {
				Ptype[plen] = 0;
			} else {
				Ptype[plen] = 1;
				P[plen][Ptmp[i]] = 1;
			}
		}

		//fprintf(stderr, "plen=%d tlen=%d\n", plen, tlen);
		
		anymatch = 0;
		for (i = 1; i <= tlen - plen + 1; i++) {
			for (j = 1; j <= plen; j++) {
				if ((Ptype[j] ^ P[j][text[i + j - 1]]) > 0)
					break;
			}
			
			if (j > plen) {
				if (anymatch)
					printf(" ");
				printf("%d", i);
				anymatch = 1;
			}
		}
		
		if (!anymatch)
			printf("no match");
		printf("\n");
	}
	
	return 0;
}
