#include <stdio.h>
#include <math.h>

double f(double x) {
	return tan(sin(x))-sin(tan(x))+pow(cos(x), 5.0)-0.5;
}

double fsample(double x) {
	return 1.0 - pow(x, 2.0);
}

int main() {
	double a, b, step, u, v, p;
	int i, N, answer;
	
	while (scanf("%lf %lf %d", &a, &b, &N) == 3) {
		answer = 0;
		step = (b - a) / N;
		u = a;
		for (i = 1; i <= N; i++, u = v) {
			v = u + step;
			p = f(u) * f(v);
			if (p < 0.0 || fabs(p) < 1e-6)
				answer++;
		}
		
		printf("%d\n", answer);
	}
	
	return 0;
}
