#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 511

vector<int> crow, ccol;
int c[NMAX][NMAX], vmin[NMAX], ccrow[NMAX], cccol[NMAX];
int N, K, i, j, k, ans, best, x, y;

int main() {
	//freopen("j.in", "r", stdin);
	int T, first;
	scanf("%d", &T);
	
	while (T--) {
		scanf("%d %d", &N, &K);
		crow.resize(N);
		ccol.resize(N);

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				scanf("%d", &c[i][j]);

		ans = -1;
		for (k = 1; k <= K; k++) {
			vmin[k] = -1;

			for (i = 0; i < N; i++)
				crow[i] = ccol[i] = 0;
			
			for (i = 1; i <= N; i++)
				ccrow[i] = cccol[i] = 0;
			
			for (i = 1; i <= N; i++)
				for (j = 1; j <= N; j++)
					if (c[i][j] == k) {
						crow[i - 1]++;
						ccol[j - 1]++;
						ccrow[i]++;
						cccol[j]++;
					}

			sort(crow.begin(), crow.end());
			sort(ccol.begin(), ccol.end());

			best = -1;
			if (crow[0] >= 2)
				best = N;
			if (ccol[0] >= 2)
				best = N;
			
			if (crow[N - 2] >= 2) {
				if (N == 2)
					best = N;
				else if (best < 0 || best > N + 2)
					best = N + 2;
			}
			
			if (ccol[N - 2] >= 2) {
				if (N == 2)
					best = N;
				else if (best < 0 || best > N + 2)
					best = N + 2;
			}
			
			// Paint just one row.
			for (i = 1; i <= N; i++)
				if (ccrow[i] >= 2) {
					for (j = 1; j <= N; j++)
						if (c[i][j] == k && cccol[j] < 2)
							break;
						else if (c[i][j] != k && cccol[j] < 1)
							break;
					if (j > N && (best < 0 || best > N + 1))
						best = N + 1;

					int none = 0;
					for (j = 1; j <= N; j++)
						if (c[i][j] != k && cccol[j] == 1) {
							none++;
						}
					if (none == 2 || (none == 1 && ccol[1] >= 2)) {
						if (best < 0 || best > N + 1)
							best = N + 1;
					}
				}
			
			// Paint just one column.
			for (j = 1; j <= N; j++)
				if (cccol[j] >= 2) {
					for (i = 1; i <= N; i++)
						if (c[i][j] == k && ccrow[i] < 2)
							break;
						else if (c[i][j] != k && ccrow[i] < 1)
							break;
					if (i > N && (best < 0 || best > N + 1))
						best = N + 1;

					int none = 0;
					for (i = 1; i <= N; i++)
						if (c[i][j] != k && ccrow[i] == 1) {
							none++;
						}
					if (none == 2 || (none == 1 && crow[1] >= 2)) {
						if (best < 0 || best > N + 1)
							best = N + 1;
					}
				}

			vmin[k] = best;
				
			if (vmin[k] >= 0 && (ans < 0 || ans > vmin[k]))
				ans = vmin[k];
		}

		if (ans < 0)
			printf("0\n");
		else {
			printf("%d\n", ans);
			first = 1;
			for (k = 1; k <= K; k++)
				if (vmin[k] == ans) {
					if (!first)
						printf(" ");
					printf("%d", k);
					first = 0;
				}
			printf("\n");
		}
	}
	
	return 0;
}
